Attribute VB_Name = "SONGPLAY1"
' MIDI and MCI API
Declare Function mciExecute Lib "winmm.dll" (ByVal a$) As Integer
Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" (ByVal lpstrCommand$, ByVal lpstrRtnString$, ByVal wRtnLength As Integer, ByVal hCallback As Integer) As String

Global FullFilePath As String
Global SongFileOpened As Integer
Global SongTempo As Integer
Global SongLength As Integer

'Current MIDI Out Port that is selected
Global MidiOutPort As Integer

' Booleans
Global Const MODAL = 1

Sub GetSongLength()
    Dim RtnString As String
    Dim Action As String

    RtnString = Space(32)
    Action = "Status " + "MCIMidi " + "length"
    Action = mciSendString(Action, RtnString, 100, 0)
    SongLength = Int(Val(RtnString) / 4)
    frmMain.LabelSongLength.Caption = "Total Length " + Str$(Int((60 / SongTempo) * SongLength / 60)) + ":" + Format$(Int((60 / SongTempo) * SongLength) Mod 60, "00")
End Sub

Sub GetSongTempo()
    Dim RtnString As String
    Dim Action As String

    RtnString = Space(32)
    Action = "Status " + "MCIMidi " + "tempo"
    Action = mciSendString(Action$, RtnString, 100, 0)
    SongTempo = Val(RtnString)
End Sub

Sub MIDIInOpen()

End Sub

Sub MIDIOutOpen()

End Sub

Sub OpenSongFile()
    Dim I As Integer
    Screen.MousePointer = 11
            
    frmMain.CMDialog1.DialogTitle = "Open Song File"
    ' Set the "Open File..." dialog to display *.mid files.
    frmMain.CMDialog1.Filter = "MIDI File (*.mid)|*.mid"
            

    ' Display the File Open... dialog.
    frmMain.CMDialog1.FilterIndex = 1
    frmMain.CMDialog1.Flags = OFN_READONLY Or OFN_FILEMUSTEXIST
    frmMain.CMDialog1.CancelError = True
    frmMain.CMDialog1.filename = ""
    On Error Resume Next
    frmMain.CMDialog1.Action = 1

    If Err <> 0 Then
        ' No file selected from the "Open File..." dialog.
        Screen.MousePointer = 0
        Exit Sub
    End If

    frmMain.Caption = "MCI Song Player - " + frmMain.CMDialog1.FileTitle
    If SongFileOpened = True Then
        ' Close previous song file
        Action$ = "Close " + "MCIMidi"
        I = mciExecute(Action$)
    End If
    
    ' Open selected song file
    Action$ = "Open " + frmMain.CMDialog1.filename + " alias " + "MCIMidi"
    I = mciExecute(Action$)

    On Error GoTo 0
    
    SongFileOpened = True
    
    RewindFlag = True
    frmMain.Label1.Caption = " 0:00"
    frmMain.MeasureScroll.Value = 0

    ' Get song tempo
    GetSongTempo
    frmMain.TempoLabel.Text = Str$(SongTempo)
    
    ' Get song length
    GetSongLength
        
    ' Setup Measure Scroll Bar
    frmMain.MeasureScroll.Max = SongLength
    
    'Enable the play control once SMF is loaded
    frmMain.Cmd_Play.Enabled = True
    frmMain.Cmd_stop.Enabled = False
    frmMain.Cmd_Rewind.Enabled = True
    frmMain.MeasureScroll.Enabled = True
    frmMain.VSliderTempo.Enabled = True
    frmMain.TempoLabel.Enabled = True

    Screen.MousePointer = 0
End Sub

Sub SetTempo()
    Dim I As Integer

    If SongFileOpened = True Then
        'Set song tempo
        Action$ = "SET " + "MCIMidi " + "TEMPO " + Str$(SongTempo)
        I = mciExecute(Action$)
        frmMain.LabelSongLength.Caption = "Total Length " + Str$(Int((60 / SongTempo) * SongLength / 60)) + ":" + Format$(Int((60 / SongTempo) * SongLength) Mod 60, "00")
    End If
End Sub

